Subject: Re: [PATCH v13 1/5] help: move list_config_help to builtin/help

From: Emily Shaffer <[email-masked]>
Date: Fri, 17 Apr 2020 12:36:22 -0700

On Thu, Apr 16, 2020 at 03:28:24PM -0700, Junio C Hamano wrote:
> 
> Junio C Hamano <[email-masked]> writes:
> 
> > Forgot to proofread and edit the log message into reasonable shape
> > when you squashed two patches together?

Less "forgot" and more "wanted to preserve origin", but I'll avoid it
next time. Thanks.

> >
> > I wonder if the "squash" action of "rebase -i" can be taught to
> > detect a mistake like this?
> 
> Without waiting for an improvement to "rebase -i" ;-), here is what
> I came up with, with a minimum edit.

Sorry to make more work for you. Thanks, it looks fine.

> 
> 
> Starting in 3ac68a93fd2, help.o began to depend on builtin/branch.o,
> builtin/clean.o, and builtin/config.o. This meant that help.o was
> unusable outside of the context of the main Git executable.
> 
> To make help.o usable by other commands again, move list_config_help()
> into builtin/help.c (where it makes sense to assume other builtin libraries
> are present).
> 
> When command-list.h is included but a member is not used, we start to
> hear a compiler warning. Since the config list is generated in a fairly
> different way than the command list, and since commands and config
> options are semantically different, move the config list into its own
> header and move the generator into its own script and build rule.
> 
> For reasons explained in 976aaedc (msvc: add a Makefile target to
> pre-generate the Visual Studio solution, 2019-07-29), some build
> artifacts we consider non-source files cannot be generated in the
> Visual Studio environment, and we already have some Makefile tweaks
> to help Visual Studio to use generated command-list.h header file.
> Do the same to a new generated file, config-list.h, introduced by
> this change.
> 
> Helped-by: Junio C Hamano <[email-masked]>
> Signed-off-by: Emily Shaffer <[email-masked]>